class
	DRIVER

inherit
	ANY
		redefine
			out
		end

create
	make

feature {NONE} -- Initialization
	make (a_name: STRING; a_address: STRING; a_date_of_birth: DATE; a_violations: ARRAYED_LIST [VIOLATION])
			-- Creation routine
		do
			name := a_name
			address := a_address
			date_of_birth := a_date_of_birth
			violations := a_violations
		end

feature -- Access
	name: STRING
			-- Full name

	address: STRING
			-- Entire mailing address

	date_of_birth: DATE
			-- TODO: Bring in time.ecf library

	age: INTEGER
			-- Age calculated from date_of_birth

	violations: ARRAYED_LIST [VIOLATION]

	violation_count: INTEGER
			-- Count of violations
		do
			Result := violations.count
		end

	pay_fee
			-- Pay fee to state authorities
		do
			print ("paid fee to state authorities")
		end

feature -- Status Report
	out: STRING
			-- formatted output
		do
			Result := "DRIVER:%N"
			Result := "name:       " + name.out + "%N"
			Result := "address:    " + address.out + "%N"
			Result := "dob:        " + date_of_birth.out + "%N"
			Result := "violation_count: " + violation_count.out + "%N"
		end
end
