class
	FRENCH_US_DRIVER

inherit
	FRENCH_DRIVER
		rename
			address as french_address,
			violations as french_violations,
			violation_count as french_violation_count,
			pay_fee as pay_french_fee
		redefine
			french_violation_count,
			out
--		select
--			french_address,
--			french_violations,
--			french_violation_count,
--			pay_french_fee
		end
	US_DRIVER
		rename
			address as us_address,
			violations as us_violations,
			violation_count as us_violation_count,
			pay_fee as pay_us_fee
		redefine
			us_violation_count,
			out
		select
			us_address,
			us_violations,
			us_violation_count,
			pay_us_fee
		end

create
	make_french_us_driver

feature {NONE} -- Initialization
	make_french_us_driver ( a_name: STRING;
							a_french_address: STRING; a_us_address: STRING;
							a_date_of_birth: DATE;
							a_french_violations: ARRAYED_LIST [VIOLATION]; a_us_violations: ARRAYED_LIST [VIOLATION])
		do
			name := a_name

			french_address := a_french_address
			my_french_address := a_french_address

			us_address := a_us_address
			my_us_address := a_us_address

			date_of_birth := a_date_of_birth

			french_violations := a_french_violations
			create my_french_violations.make (a_french_violations.count)
			my_french_violations.copy (a_french_violations)

			us_violations := a_us_violations
			create my_us_violations.make (a_us_violations.count)
			my_us_violations.copy (a_us_violations)
		end

feature -- Status Report
	french_violation_count: INTEGER
			-- Count of French violations
		do
			Result := my_french_violations.count
		end

	us_violation_count: INTEGER
			-- Count of US violations
		do
			Result := my_us_violations.count
		end

	my_us_address: STRING
	my_french_address: STRING

	my_us_violations: ARRAYED_LIST [VIOLATION]
	my_french_violations: ARRAYED_LIST [VIOLATION]

	out: STRING
		do
			Result := "FRENCH_US_DRIVER:%N"
			Result := Result + "name:                   " + name.out + "%N"
			Result := Result + "french_address:         " + my_french_address.out + "%N"
			Result := Result + "us_address:             " + my_us_address.out + "%N"
			Result := Result + "dob:                    " + date_of_birth.out + "%N"
			Result := Result + "french_violation_count: " + french_violation_count.out + "%N"
			Result := Result + "us_violation_count:     " + us_violation_count.out + "%N"
		end
end
